HDU 1242 Rescue(BFS+优先队列)

题目链接:点击打开链接

                                                  Rescue

                                                          Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
                                                          Total Submission(s): 23823    Accepted Submission(s): 8417


Problem Description
Angel was caught by the MOLIGPY! He was put in prison by Moligpy. The prison is described as a N * M (N, M <= 200) matrix. There are WALLs, ROADs, and GUARDs in the prison.

Angel's friends want to save Angel. Their task is: approach Angel. We assume that "approach Angel" is to get to the position where Angel stays. When there's a guard in the grid, we must kill him (or her?) to move into the grid. We assume that we moving up, down, right, left takes us 1 unit time, and killing a guard takes 1 unit time, too. And we are strong enough to kill all the guards.

You have to calculate the minimal time to approach Angel. (We can move only UP, DOWN, LEFT and RIGHT, to the neighbor grid within bound, of course.)
 

Input
First line contains two integers stand for N and M.

Then N lines follows, every line has M characters. "." stands for road, "a" stands for Angel, and "r" stands for each of Angel's friend.

Process to the end of the file.
 

Output
For each test case, your program should output a single integer, standing for the minimal time needed. If such a number does no exist, you should output a line containing "Poor ANGEL has to stay in the prison all his life."
 

Sample Input
  
  
7 8 #.#####. #.a#..r. #..#x... ..#..#.# #...##.. .#...... ........
 

Sample Output
  
  
13
 

Author
CHEN, Xue
 

Source

题意:X代表卫兵,a代表终点,r代表起始点,.代表路,#代表墙

路花费一秒,x花费两秒

问到达终点的最少时间

因为r可能有很多个,所以从a点开始BFS,找到的第一个r为最短时间,遇到’x’点是,时间+2,如果用普通的队列就并不能保证每次出队的是时间最小的元素,所以要用优先队列。

第一道优先队列题,其实还不会~~

代码:

#include<stdio.h>
#include<string.h>
#include<queue>
using namespace std;
int visit[210][210],n,m;int dir[4][2]={-1,0,0,-1,0,1,1,0};
char s[210][210];
struct node
{
    int x,y,step;
    friend bool operator < (const node &a,const node &b)  
    {
        return a.step>b.step;
    }
};
int bfs(int a,int b)
{
   int i;
   priority_queue<node>q;
   node now,next;
   now.x=a;now.y=b;now.step=0;
   visit[now.x][now.y]=1;
   q.push(now);
   while(!q.empty())
   {
       now=q.top();
       q.pop();
       if(s[now.x][now.y]=='r') return now.step;
       for(i=0;i<4;i++)
       {
           next.x=now.x+dir[i][0];
           next.y=now.y+dir[i][1];
           if(next.x>=0&&next.x<n&&next.y>=0&&next.y<m&&s[next.x][next.y]!='#'&&visit[next.x][next.y]!=1)
           {
               visit[next.x][next.y]=1;
               if(s[next.x][next.y]=='x') next.step=now.step+2;
               else next.step=now.step+1;
               q.push(next);
           }
       }
   }
   return -1;

}
int main()
{
     int  i,j,a,b,c,d,ans;
     while(scanf("%d%d",&n,&m)!=EOF)
     {
         memset(visit,0,sizeof(visit));
         for(i=0;i<n;i++)
         scanf("%s",s[i]);
         for(i=0;i<n;i++)
         {
            for(j=0;j<m;j++)
            {
              if(s[i][j]=='a') {a=i;b=j;break;}
            }
         }
        ans=bfs(a,b);
        if(ans==-1) printf("Poor ANGEL has to stay in the prison all his life.\n");
        else printf("%d\n",ans);
     }
}



对于HDU4546问题,还可以使用优先队列(Priority Queue)来解决。以下是使用优先队列的解法思路: 1. 首先,将数组a进行排序,以便后续处理。 2. 创建一个优先队列(最小堆),用于存储组合之和的候选值。 3. 初始化优先队列,将初始情况(即前0个数的组合之和)加入队列。 4. 开始从1到n遍历数组a的元素,对于每个元素a[i],将当前队列中的所有候选值取出,分别加上a[i],然后再将加和的结果作为新的候选值加入队列。 5. 重复步骤4直到遍历完所有元素。 6. 当队列的大小超过k时,将队列中的最小值弹出。 7. 最后,队列中的所有候选值之和即为前k小的组合之和。 以下是使用优先队列解决HDU4546问题的代码示例: ```cpp #include <iostream> #include <vector> #include <queue> #include <functional> using namespace std; int main() { int n, k; cin >> n >> k; vector<int> a(n); for (int i = 0; i < n; i++) { cin >> a[i]; } sort(a.begin(), a.end()); // 对数组a进行排序 priority_queue<long long, vector<long long>, greater<long long>> pq; // 最小堆 pq.push(0); // 初始情况,前0个数的组合之和为0 for (int i = 0; i < n; i++) { long long num = pq.top(); // 取出当前队列中的最小值 pq.pop(); for (int j = i + 1; j <= n; j++) { pq.push(num + a[i]); // 将所有加和结果作为新的候选值加入队列 num += a[i]; } if (pq.size() > k) { pq.pop(); // 当队列大小超过k时,弹出最小值 } } long long sum = 0; while (!pq.empty()) { sum += pq.top(); // 求队列中所有候选值之和 pq.pop(); } cout << sum << endl; return 0; } ``` 使用优先队列的方法可以有效地找到前k小的组合之和,时间复杂度为O(nklog(k))。希望这个解法对你有所帮助!
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值